; LAST UPDATED ON:	05 FEB 85 -- Ver 2.2Q
; REASON FOR UPDATE:	Removed HMX1BIOS and HMXIO overlay.  Unified the BIOS.
;			Created loader w/CCP overlay similar to CP/M-86.    jrs
; 04 FEB 85, VER 2.2P	Added DISK1A driver code and 5" floppy disk boot    jrs
; 20 JUN 84, Ver 2.2Na	Q520 DPB & fix ST506 DPB			    rrs
; 02 DEC 83, Ver 2.2N	Fixed sizing bug for 4 M-DRIVE/H's                  llo
; 10 OCT 82, Ver 2.2M	Changed DISK3 for new firmware.  Change M-DRIVE/H
;                       to be consistent with other CompuPro OS's           llo
;
; 10 JUN 83, Ver 2.2i	Add DISK3 driver as per initial specs.		    aep
; 25 MAY 83, Ver 2.2h	Add format structure to sector xlate table.  Move I/O
;			initialization to the boot loader to achieve invariance
;			against CBIOS size variations.			    aep
; 03 MAY 83, Ver 2.2g	Continued debug and streamline of DISK2 driver with
;			addition for multiple drives.  BIOS split to permit
;			boot from floppy of hard disk drivers in addition to
;			full I/O compliment (loaded by file in "STARTUP.SUB"
;			sequence.)					    aep
; 24 MAR 83, Ver 2.2f	Update M-Drive/H with message, restructure hard disk
;			driver for faster algorythm including relocation of up
;			to one track's worth of "bad media" sectors.	    aep
; 02 JAN 83, Ver 2.2e	General debug of M-DRIVE/H.			    aep
; 16 NOV 82, Ver 2.2e	Add M-DRIVE/H driver.				    aep
; 10 OCT 82, Ver 2.2d	Add DISK2 controller software to match existing
; 15 JUL 82, Ver 2.2L	Modify to accomodate use of boot switch again,
;			eliminate bit banger.				    aep
; 16 MAY 82, Ver 2.2LXmMN Restructure code (massive overhaul) to permit
;			interrupt handler overlay.			    aep
; 25 MAR 82, Ver 2.2LXM	Add mini-drives, M-BOOT, fix SPECIFY,
;			full I/O byte implimentation.			    aep
;
; PROGRAM NAME:	HMXBIOS.ASM	-- Customized BIOS for CP/M-80 version 2.2,
;		developed for use with CompuPro Systems Components.
;
;	==========================	Copyright 1985, Viasyn Corporation.
;	||			||
;	||     LDRBIOS.ASM	||
;	||			||
;	==========================
;
; CONSTANTS:
VERS	EQU	22	;CP/M version number
CBIOSV	EQU	'Q'	;CBIOS revision level (2.2x) (CompuPro level)
;
; LIBRARY CONSTANTS:
    MACLIB  COMPUPRO	;Disk and Serial/Parallel interface constants
    MACLIB  ASCII	;Mnemonics for common ASCII, other special characters
    MACLIB  LDRACT	;Flags directing construction for the various
			;CompuPro products to "customize" the BIOS
    MACLIB  CPMDISK	;CP/M disk defaults, CBIOS offsets, BDOS functions
    MACLIB  BOOTSCPM	;CP/M cold/warm boot routines for each of the
			;possible controller types
;
    PAGE
;
; PROGRAM:
;
; The next statement produces a harmless error message if MAC is used instead.
    ASEG		;Used Digital Research RMAC assembler and
	ORG	BIOS	;LINK linker to assemble this code
;
	JMP	CBOOT	;+00h	Cold boot
LOADVEC EQU	BIOS+1	;Base vector address of interrupt or other code loaded
			;by CP/M to extend the CBIOS beyond what the boot track
			;can hold -- value stored here at end of cold boot.
	JMP	WBOOT	;+03h	Warm boot
CIS:	JMP	CONST	;+06h	Console status (input)
CI:	JMP	CONIN	;+09h	Console input
CO:	JMP	CONOUT	;+0Ch	Console output
	JMP	LISTOUT	;+0Fh	List output
	JMP	PUNCH	;+12h	Punch output
	JMP	READER	;+15h	Reader input
	JMP	HOME	;+18h	Set track to zero
	JMP	SELDSK	;+1Bh	Select disk unit
	JMP	SETTRK	;+1Eh	Set track
	JMP	SETSEC	;+21h	Set sector
	JMP	SETDMA	;+24h	Set Disk Memory Address
	JMP	READ	;+27h	Read from disk
	JMP	WRITE	;+2Ah	Write onto disk
	JMP	LISTST	;+2Dh	List status (output)
	JMP	SECTRN	;+30h	Translate sector number
	JMP	SETNUM	;+33h	Set number of sectors to R/W (dangerous)
	JMP	SETXAD	;+36h	Set extended address (unblocked data only)
;
    PAGE
;
;****************************************************************
;*	DISK LOGICAL TO PHYSICAL SECTOR TRANSLATION TABLES	*
;****************************************************************
    if FLOPPY8
;			GPL1,	GPL2,	Physical sectors/track
X8TABLE:DW  XLT8S0			  	  ;Single 128
	   DB		 07h,	 1Bh,	 26,	0 ;Format information "header"
	DW  XLT8D1			  	  ;Double 256
	   DB		 0Eh,	 36h,	 26,	0
	DW  XLT8D2			  	  ;Double 512
	   DB		 1Bh,	 54h,	 15,	0
	DW  XLT8D3			  	  ;Double 1024
	   DB	 	 35h,	 74h,	 08,	0
;---------------------------------------
XLT8S0:	DB	0,6,12,18,24,4,10,16,22,2,8,14,20
	DB	1,7,13,19,25,5,11,17,23,3,9,15,21
;---------------------------------------
XLT8D1:	DB	 0, 1,18,19,36,37, 2, 3,20,21,38,39
	DB	 4, 5,22,23,40,41, 6, 7,24,25,42,43
	DB	 8, 9,26,27,44,45,10,11,28,29,46,47
	DB	12,13,30,31,48,49,14,15,32,33,50,51
	DB	16,17,34,35
;---------------------------------------
XLT8D2:	DB	 0, 1, 2, 3,16,17,18,19
	DB	32,33,34,35,48,49,50,51
	DB	 4, 5, 6, 7,20,21,22,23
	DB	36,37,38,39,52,53,54,55
	DB	 8, 9,10,11,24,25,26,27
	DB	40,41,42,43,56,57,58,59
	DB	12,13,14,15,28,29,30,31
	DB	44,45,46,47
;---------------------------------------
XLT8D3:	DB	 0, 1, 2, 3, 4, 5, 6, 7
	DB	24,25,26,27,28,29,30,31
	DB	48,49,50,51,52,53,54,55
	DB	 8, 9,10,11,12,13,14,15
	DB	32,33,34,35,36,37,38,39
	DB	56,57,58,59,60,61,62,63
	DB	16,17,18,19,20,21,22,23
	DB	40,41,42,43,44,45,46,47
    endif
;
    PAGE
;=======================================
    if FLOPPY5
;			GPL1,	GPL2,	Physical sectors/track
X5TABLE:
	DW  XLT5S0			  ;Single 128
	   DB		 08h,	 10h,	 16,	0 ;Format information
;	   DB		 07h,	 09h,	 18,	0 ;Optional replacement (tight)
	DW  XLT5D1			  ;Double 256
	   DB		 10h,	 19h,	 16,	0
;	   DB		 07h,	 09h,	 18,	0 ;Optional replacement (tight)
	DW  XLT5D2			  ;Double 512
	   DB	 	 2Ah,	 50h,	 08,	0
	DW  XLT5D3			  ;Double 1024
;	   DB		 2Ah,	 50h,	 04,	0 ;Optional replacement (loose)
	   DB		 20h,	 32h,	 05,	0
;---------------------------------------
XLT5S0:	DB	 0, 5,10,15, 4, 9,14, 3		; 0, 5,10,15, 2, 7,12,17
	DB	 8,13, 2, 7,12, 1, 6,11		; 4, 9,14, 1, 6,11,16, 3
	DB	00,00				; 8,13
;---------------------------------------
XLT5D1:	DB	 0, 1,10,11,20,21,30,31		; 0, 1,10,11,20,21,30,31
	DB	 8, 9,18,19,28,29		; 4, 5,14,15,24,25,34,35
	DB	 6, 7,16,17,26,27		; 8, 9,18,19,28,29
	DB	 4, 5,14,15,24,25		; 2, 3,12,13,22,23,32,33
	DB	 2, 3,12,13,22,23,00,00,00,00	; 6, 7,16,17,26,27
;---------------------------------------
XLT5D2:	DB	 0, 1, 2, 3,16,17,18,19
	DB	12,13,14,15,28,29,30,31
	DB	 8, 9,10,11,24,25,26,27
	DB	 4, 5, 6, 7,20,21,22,23
	DB	00,00,00,00,00,00,00,00	;Additional space for other allocations
;---------------------------------------
XLT5D3:	DB	 0, 1, 2, 3, 4, 5, 6, 7
	DB	16,17,18,19,20,21,22,23
	DB	32,33,34,35,36,37,38,39
	DB	 8, 9,10,11,12,13,14,15
	DB	24,25,26,27,28,29,30,31
    endif
	PAGE
;****************************************************************
;*	Macro for generating the Disk Parameter Blocks.		*
;****************************************************************
;
; Control Blocks (DPB's in CP/M-eze) for disk drives:
;
;   MAKEDPB	Name, Type, Heads, Sectors/Track, Records(128 bytes)/sector,
;		Reserved cylinders, Ending cylinder number (starting at 1),
;		Allocation block size (in bytes from 1024 to 16*1024)
;		Directory entries, # of directory entries to be checked
;	(and optional),0 will force 16K extents for CP/M 1.4 compatibility
;
MAKEDPB MACRO	?NM,TY,HDS,SPT,SIR,?F,?L,BLS,NDIR,NCKS,K16
BSF	SET	3	;;Init block shift factor
EXTMSK	SET	0	;;Init extent mask
ACCU	SET BLS/1024
   REPT 6		;;6 bit shift max
      if ACCU = 1
	EXITM
      endif
BSF	SET BSF+1	;;Bump block shift factor
EXTMSK	SET 1+(EXTMSK*2);;Shift in a bit from right
ACCU	SET ACCU/2	;;Shift 1 bit right until in zero position
   ENDM
SIB	SET BLS/128	;;Sectors in block
DSMC	SET ((((?L*HDS)-(?F))*SPT*SIR)+SIB-1)/SIB ;;Maximum data blocks
      if DSMC > 256
EXTMSK	SET EXTMSK/2	;;Shift out one for double byte allocation
      endif
      if not NUL K16	;;optional [0] in last position
EXTMSK	SET	K16	;;forces 16K extent mask
      endif
DIRBLK	SET	8000h	;;Init allocation block for directory
ADIR	SET	BLS/32	;;32 bytes/dir entry
ACCU	SET	NDIR	;;Set accumulator to number of dir entries
   REPT 15		;;16 Bits of directory alloc max
ACCU	SET ACCU-(ADIR)	;;32 bytes per directory entry
      if ACCU <= 0	;;Done when all accounted for
	EXITM
      endif		;;Subtract # of entries in one block
DIRBLK	SET (DIRBLK/2)+8000h;;Shift in one bit from the left
   ENDM
      if (TY > 40h) and (TY < 80h)
DIRBLK	SET 0FFFFh	;;Reserve all dir blocks for hard disks
      endif
;;
;;---- Disk Parameter Block Generated ----
;;
;;	Disk type definition blocks for each particular mode.
;;	The produced format of these areas are as follows:
;;
;; 8 bit  = disk type code (not standard CP/M)
;; 16 bit = Sectors per track (real start of DPB)
;; 8 bit  = Block shift factor (block size in 128 byte segments)
;; 8 bit  = Block Shift mask
;; 8 bit  = Extent mask (a somewhat magical number best left alone)
;; 16 bit = Disk size in blocks (less 1 -- for expansion purposes)
;; 16 bit = Directory size. (less 1 in case size = 64K)
;; 16 bit = Allocation for directory. (vector to bitmap for this drive)
;; 16 bit = Check size. (# of 128 byte directory segments for checksums)
;; 16 bit = Offset to first track. (# of reserved cylinders to this drive)
	DB TY				;;Disk type identifier
DPB&?NM	DW SPT * SIR			;;Sectors/track
	DB BSF,	SIB-1,	EXTMSK		;;Block size factor, records/blk, mask
	DW DSMC-1,	NDIR-1		;;Disk size (blocks), Directory entries
	DB high DIRBLK,	low DIRBLK	;;Directory allocation reserved blocks
	DW (NCKS+3)/4,	?F 		;;Checksum vector size, reserved tracks
?NM&CSVZ EQU (NCKS+3)/4	;;Checksum vector size
?NM&ALVZ EQU (DSMC+7)/8	;;Max allocation vector size (bytes = blocks / 8 bits)
   ENDM
;
    if FLOPPY8
DPB8TBL:	;8 inch floppy disk DPB table
  MAKEDPB	F8S0,	00h,	1,26,1,	   2,77,	1024,	 64, 64
  MAKEDPB	F8S1,	01h,	2,26,1,	 2*2,77,	1024,	128,128
  MAKEDPB	F8D2,	02h,	1,26,2,	   2,77,	2048,	128,128, 0 ;16K extents
  MAKEDPB	F8D3,	03h,	2,26,2,	 2*2,77,	2048,	256,256
  MAKEDPB	F8D4,	04h,	1,15,4,	   2,77,	2048,	128,128
  MAKEDPB	F8D5,	05h,	2,15,4,	 2*2,77,	2048,	256,256
  MAKEDPB	F8D6,	06h,	1, 8,8,	   2,77,	2048,	128,128
  MAKEDPB	F8D7,	07h,	2, 8,8,	 2*2,77,	2048,	256,256
FD8CSVZ	EQU  F8D7CSVZ	;Max checksum vector size (4 dir entries / record)
FD8ALVZ	EQU  F8D7ALVZ	;Max allocation vector size (bytes = blocks / 8 bits)
DPBFD8	EQU  DPBF8D7	;DPB with largest size alloc, checksum vectors
;
    endif
    if FLOPPY5
DPB5TBL:	;5 1/4 inch floppy disk DPB table
;	TYPE base = 20h, then 77 tracks
;	TYPE base = 28h, then 40 tracks
;	TYPE base = 30h, then 80 tracks
  MAKEDPB  F5S0,  BIAS5+0,   1,16,1,	 2,	TRK5,  1024,	 64, 64
  MAKEDPB  F5S1,  BIAS5+1,   2,16,1,	 2*2,	TRK5,  1024,	128,128
  MAKEDPB  F5D2,  BIAS5+2,   1,16,2,	 2,	TRK5,  2048,	128,128, 0 ;16K
  MAKEDPB  F5D3,  BIAS5+3,   2,16,2,	 2*2,	TRK5,  2048,	256,256
  MAKEDPB  F5D4,  BIAS5+4,   1, 8,4,	 2,	TRK5,  2048,	128,128
  MAKEDPB  F5D5,  BIAS5+5,   2, 8,4,	 2*2,	TRK5,  2048,	256,256
  MAKEDPB  F5D6,  BIAS5+6,   1, 5,8,	 2,	TRK5,  2048,	128,128
  MAKEDPB  F5D7,  BIAS5+7,   2, 5,8,	 2*2,	TRK5,  2048,	256,256
FD5CSVZ	EQU  F5D7CSVZ	;Max checksum vector size (4 dir entries / record)
FD5ALVZ	EQU  F5D7ALVZ	;Max allocation vector size (bytes = blocks / 8 bits)
DPBFD5	EQU  DPBF5D7	;DPB with largest size alloc, checksum vectors
    endif
;
    if DISK2	;Disk 2 hard disk controller active.
      if D2M10		;Memorex (Fujitsu) 10 Mbyte drive
  MAKEDPB	D2N1,	43h,	4,11,8,	  4*1,123,  4096,  1024,0	;First 5M
      endif
      if D2M20		;Memorex (Fujitsu) 20 Mbyte drive
  MAKEDPB	D2N1,	43h,	8,11,8,	  8*1, 94,  4096,  1024,0	;First 8M
      endif
      if D2F20B		;Fujitsu "BE" 20 Mbyte drive
  MAKEDPB	D2N1,	43h,	4,22,8,	  8*1, 94,  4096,  1024,0	;First 8M
      endif
      if D2M26		;Shugart 26 Mbyte drive
  MAKEDPB	D2N1,	43h,	8,16,8,	  8*1, 57,  4096,  1024,0	;First 8M
      endif
      if D2F40B		;Fujitsu "BE" 40 Mbyte drive
  MAKEDPB	D2N1,	43h,	8,22,8,   8*1, 47,  4096,  1024,0	;First 8M
      endif
    endif
;
    if DISK3	;Disk 3 hard disk controller active.
      if D3ST506	;Seagate  5 Mbyte drive (ST506)
  MAKEDPB	D3N1,	53h,	4,9,8,	  2,149,  4096,  1024,0	;First 5M
      endif
      if D3M20		; 20 Mbyte drive
  MAKEDPB	D3N1,	53h,	8,9,8,	  1, 57,  4096,  1024,0	;First 8M
      endif
      if D3Q520		; 20 Mbyte Quantum drive
  MAKEDPB 	D3N1,	53h,	4,9,8,         2,145,  4096,  1024,0	;First 5.2M
      endif
      if D3Q540		; 40 Mbyte Quantum drive
  MAKEDPB	D3N1,	53h,	8,9,8,	       2, 72,  4096,  1024,0	;First 5M
      endif
    endif
;
	PAGE
;************************************************************************
;*	Macro for generating Control Headers for disk drives (DPH's):	*
;************************************************************************
;
; Set all letter drives to not in use status.
	IRPC	?X,ABCDEFGHIJKLMNOP
DRV&?X	SET	0
ALVZ&?X	SET	0
CSVZ&?X	SET	0
	ENDM
;
; The produced format of these Disk Parameter Headers are as follows:
;  8 bits = Mask for drive selection (drive dependent and not std CP/M)
; 16 bits = -> translation table. (real start of DPH)
; 48 bits = Work area for CP/M.
; 16 bits = -> DIRBUF.
; 16 bits = -> Parameter block.
; 16 bits = -> check vector.
; 16 bits = -> allocation vector.
;
; To generate a DPH, use the format:
;       MAKEDPH Drive letter, Physical drive selection mask,
;		Initial Sector translation table for that drive,
;		Initial DPB call letter name (see first entry of MAKEDPB).
;
MAKEDPH MACRO	?DR,?MASK,?XLT,?DPBN
;; ?DR	 = disk name [A,B,C,...,P]
;; ?MASK = disk selection mask for port control
;; ?XLT	 = sector translation table address
;; ?DPBN = code name for largest corresponding DPB
DRV&?DR	SET	$
	DB	?MASK		;;Address of this drive letter's DPH
DPH&?DR	DW	?XLT		;;Sector translation table
	DW  0000h, 0000h, 0000h	;;Scratchpad for CP/M
	DW  DIRBUF, DPB&?DPBN	;;Dir buffer, disk parameter block
	DW  CSV&?DR, ALV&?DR	;;Checksum vector, Allocation vector start
CSVZ&?DR SET	?DPBN&CSVZ	;;Set checksum vector reserve size
ALVZ&?DR SET	?DPBN&ALVZ	;;Set allocation vector reserve size
    ENDM
;
    if not (DISK2 or DISK3)				;=1
; Floppy disks are only permanent storage.
      if not (FLOPPY5 and BOOT5X)			;=2
  MAKEDPH  A, 00h, XLT8D3, FD8	;Drive A: 8 inch floppy
      else		;Booting from 5 1/4 inch disks	;=2
	if DISK1
  MAKEDPH  A, 00h, XLT5D3, FD5	;Drive A: 5 inch floppy
	endif
	if DISK1A
  MAKEDPH  A, 02h, XLT5D3, FD5	;Drive A: 5 inch floppy
	endif
      endif						;=2
    else						;=1
; Hard Disks exist, and should be used for drive A:
      if D2M10		;If Memorex 10 megabyte drive	;=2
D2UNIT0	EQU  'A' - 'A'	;Unit #0 base drive ID select
  MAKEDPH  A, 10h, 00, D2N1	;Drive A: 8 inch hard disk, select #0, 8M
      endif						;=2
      if (D2M20 or D2F20B)	;If Memorex 20 megabyte drive	;=2
				; or Fujitsu "BE" 20 megabyte drive
D2UNIT0	EQU  'A' - 'A'	;Unit #0 base drive ID select
  MAKEDPH  A, 10h, 00, D2N1	;Drive A: 8 inch hard disk, select #0, 8M
      endif						;=2
      if D2M26		;If Shugart 26 megabyte drive	;=2
D2UNIT0	EQU  'A' - 'A'	;Unit #0 base drive ID select
  MAKEDPH  A, 10h, 00, D2N1	;Drive A: 14 inch hard disk, select #0, 8M
      endif						;=2
      if D2F40B		;If Fujitsu "BE" 40 megabyte drive	;=2
D2UNIT0	EQU  'A' - 'A'	;Unit #0 base drive ID select
  MAKEDPH  A, 10h, 00, D2N1	;Drive A: 8 inch hard disk, select #0, 8M
      endif						;=2
      if DISK3
	if D3ST506
  MAKEDPH  A, 00h, 00, D3N1	;Drive G: 5 inch hard disk, select #0, 5M
	endif
	if D3Q520
  MAKEDPH  A, 00h, 00, D3N1	;Drive G: 5 inch hard disk, select #0, 5.2M
        endif
	if D3Q540
  MAKEDPH  A, 00h, 00, D3N1	;Drive G: 5 inch hard disk, select #0, 5M
        endif
      endif
    endif						;=1
	PAGE
;----------------------------------------
;
;	HOME ROUTINE:
;
; Return disk to home.  This routine sets the track number to zero.
; The current host disk buffer is flushed to the disk, and made inactive.
;
HOME:	CALL	HSTOFF		;Clear host active flag
	LHLD	SEKDSK		;Move desired drive, type back to active
	SHLD	ACTDSK
	LDA	SAVSEC		;Restore last desired sector to active status
	STA	ACTSEC
	LDA	SEKGPL		;Restore associated Gap Length for floppies
	STA	ACTGPL
	LHLD	DMAADR		;Move selected transfer address to
	SHLD	BUFADR		;the internal buffer address pointer
	XRA	A		;Clear the extended DMA byte (always bank 0)
	STA	DMAADE
	STA	BUFADE		;and extended buffer DMA address
	LXI	B,0		;Init to track 0 (theoretical position)
;
;----------------------------------------
;
;	SET TRACK ROUTINE:
;
; Set track number.  The track number is saved for later use during
; a disk transfer operation.
;
;Entry:	B,C = track number.
;
SETTRK:	MOV L,C! MOV H,B	;Put track number in "H,L"
	SHLD	ACTTRK		;Save as active track number
	SHLD	SEKTRK		;And as desired (blocking/deblocking)
	RET
;
;----------------------------------------
;
;	SECTOR TRANSLATION ROUTINE:
;
; Translate sector number from logical to physical.
;
;Entry:	D,E = 0, then no translation required,
; else:	D,E = translation table address and
;	B,C = sector number to translate.
;
;Exit:	H,L = translated sector number.
;
SECTRN:	MOV L,C! MOV H,B	;Offset (or record #) in H,L
	MOV A,E! ORA D		;See if translation required
	RZ			;Done if not
	DAD	D		;Add base to offset
	MOV L,M! MVI H,0	;Translation is always 1 byte for floppies
	RET
;
;----------------------------------------
;
;	SET SECTOR ROUTINE:
;
; Set the sector for later use in the disk transfer.  No
; actual disk operations are perfomed.
;
;Entry:	B,C = sector number (sometimes "B" contains an invalid number
;		if less than 256 sectors used for selected drive).
;
SETSEC:	MOV	A,C
	STA	ACTSEC		;Sector to seek
	STA	SAVSEC		;Special save area for blocking/deblocking
	RET
;
;----------------------------------------
;
;	SET NUMBER OF CONTINUOUS SECTORS TO USE:
;
; Set the number of sectors to be used during a single transfer.  This
; is a potentially dangerous value to alter in that the READ and WRITE
; routines will currently only use this value correctly if the disk
; is marked as "non-blocked", or having 128 byte sectors.  Unless you
; really have a need to alter this value, leave it at "1".
;
;Entry:	C = number of sectors to use in the next disk transfer.
;
SETNUM:	MOV	A,C
	STA	NUMSEC
	RET
;
;----------------------------------------
;
;	SET DIRECT MEMORY ACCESS (Lower 2 bytes):
;
; Set Direct Memory Address (DMA) for subsequent disk read or
; write routines.  This is the place the actual requested 128
; byte record (CP/M 1.4 sector) goes.
;
;Entry:	B,C = Disk memory address.
;
SETDMA:	MOV H,B! MOV L,C
	SHLD	DMAADR		;Save as Direct Memory Access start byte
	SHLD	BUFADR		;And as desired (blocking/deblocking)
	RET
;
;----------------------------------------
;
;	SET DIRECT MEMORY ACCESS (Upper byte of 24 bit address):
;
; Set extended bank address of DMA as above, currently inactive due
; to the potential havoc it wreaks if not used very, very carefully.
;
;Entry:	C = extended bank address byte.
;
SETXAD:	MOV	A,C		;Get extended address byte from "C"
	STA	DMAADE		;Save in memory
	RET
;
;----------------------------------------
;
; Create disk drive "existance" table to the actual drives presesnt.  This
; makes a list of the relative DBH's for individual logical drives which occupy
; absolute letter identifications.  Those logical drives with no associated
; physical counterpart have their pointers set to zero, indicating an invalid
; or non-existant drive.
;
DSKTBL:	IRPC	?D,ABCDEFGHIJKLMNOP
	DW	DRV$&?D
	ENDM
;
;	SELECT DISK DRIVE:
;
; Select the disk drive for subsequent disk transfers and return the
; appropriate DPB address.   This routine diverges from the normal CP/M
; implementation of just saving the disk selection value until the
; transfer is performed.  This divergence is required because floppy
; disks are a removable media and come in more than on format.  This
; routine determines the correct format and initializes the DPH with
; the appropriate values in agreement with the format type.
;
;Entry:	C = Disk selection value.
;	D,E and 1 = 0, ==> Must determine disk type,
;  else	          = 1, ==> Drive type has been determined.
;
;Exit:	H,L = 0, If drive not selectable,
;	H,L = DPH address if drive is selectable, and is initialized for the
;		appropriate floppy disk format if D,E = 0,
;	else the DPH pointed to contains data about the last disk accessed,
;  (the following are not required by CP/M, but are by the FORMAT utility)
;	D,E = DPB address if floppy disk was selected and initialized,
;	B,C = Base address of sector translate, format info if floppy selected.
;
SELDSK:	LXI	H,0		;Indicate not found or drive not active
	MOV A,C!  CPI 16!  RNC	;Done if invalid drive specified
	ADI	'A'		;Add in ASCII bias to drive ID
	STA	NRDYM2		;Set drive letter into "not ready" message
	MOV	B,H		;Clear upper byte of offset word
	LXI	H,DSKTBL	;Base of disk DPH lookup table
	DAD B!	DAD B		;Add offset times 2
	MOV A,M!  INX H		;Get low order byte of DPH pointer
	MOV H,M!  MOV L,A	;Get word DPH pointer in "H,L"
	ORA H!	JZ SELINV	;Check for valid drive, done if not
;
	MOV	A,M		;Get disk selection mask
	STA	ACTDSK		;Set into ACTDSK (make active disk)
	STA	SEKDSK		;And desired (seek to)
	INX	H		;Point to true DPH
	PUSH	H		;Save DPH address
	LXI	B,5*2		;Add offset within DPH to its DPB pointer
	DAD	B		;Result in "H,L" = DPH(DPB)
	MOV C,M! INX H		;Put start of DBP in "B,C"
	MOV B,M! DCX B		;Point to disk type for this DPH
	LDAX	B		;Get it
	STA	ACTTYP		;Save active disk type
	STA	SEKTYP		;And desired
	POP	H		;Restore DPH address
	CPI	D2$TYPE		;See if fixed media (starting hard disk type)
	RNC			;Done if hard disk or memory drive
;
    if FLOPPY8
	LXI	B,X8TABLE	;Show format parameter table base
    endif
    if (FLOPPY5 and not FLOPPY8)
	LXI	B,X5TABLE	;Show format parmaeter table base
    endif
    if FLOPPY5
	CPI	FD5TYPE		;See if 5 1/4 inch disk type
	JC	SEL8XLT		;Use that format table if so
	LXI	B,X5TABLE	;5 1/4 format parameter table base
SEL8XLT:CALL	FIX58		;Patch controller ports or set data rate clock
    endif
	MOV A,E! ANI 1		;Mask "Force selected" bit, set status
	RNZ			;Done if drive previously selected
;
	PUSH B!	PUSH H		;Save XLATE, DPH address again
	CALL	TREAD		;Determine disk type
	POP D!	POP B		;Restore DPH, XLATE address
	LXI	H,0		;Indicate drive not active
	RNZ			;If disk type determined, fix DPH to match
;
FIX$DPH:PUSH B!	PUSH D		;Save base of track info, Drive's DPH address
    if FLOPPY8
	LXI	D,DPB8TBL+1	;Get base of DPB's to get correct one
    endif
    if (FLOPPY5 and not FLOPPY8)
	LXI	D,DPB5TBL+1	;Get base of DPB's to get correct one
    endif
    if (FLOPPY5 and FLOPPY8)
	CPI	FD5TYPE		;See if 5 1/4 inch disk type
	JC	FIX8DPB		;Use that format table if so
	LXI	D,DPB5TBL+1	;Get, save base of DPB's to get correct one
    endif
FIX8DPB:ANI 07h!  MOV L,A	;Get disk type for DPB locate in "H,L"
	DAD H!	DAD H		;times 4
	DAD H!	DAD H		;times 4 = 16 bytes/DPB
	XCHG!	DAD D!	XCHG	;Add base of DPB's to get correct one in "D,E"
	ANI 6! MOV L,A! ADD A	;Remove "sided" bit (offset 2X), times 2 = 4X
	ADD L!	MOV L,A		;Plus 2X = 6X, offset to table in "H,L"
	DAD	B		;Add "Sector translation" base to offset
	POP B!	PUSH B		;Recover, save again DPH base address
	MOV A,M!  STAX B	;Set translation table address into DPH
	INX H!	  INX B		; as word value
	MOV A,M!  STAX B	;At start of DPH
	INX H!	MOV A,M		;Point to associated Gap 3 Length, get it
	STA	SEKGPL		;Save for read/write operations
	STA	ACTGPL
	LXI	H,(5*2)-1	;Offset from present DPH address to DPB pointer
	DAD	B		;Move current pointer to DPH [DPB] pointer
	MOV	M,E!	INX H	;Set DPB address into DPH
	MOV	M,D
	POP H!	POP B		;Restore DPH start address, format table base
	RET
SELINV:
	STA	CDISK		;Put zero in A so drive A: is selected   
	RET                     ;  upon selection of nonexistent drive   
;
;	TREAD - Determine floppy disk type.
;
;Exit:	Zbit set = no error and
;	A = disk type (8n + (0-7)) if 8 inch.
;		      (8n + 20h + (0-7)) if 5 1/4 inch.
;			n = 0-3 depending on the number of cylinders/drive.
;
TREAD:	CALL	GTREADY		;Ask for drive status
	RNZ			;Abort if not ready
	LDA	TEMPBF		;Get status byte
	ANI	FD2SIDE		;Mask TS (two sided) bit
	RRC!	RRC!	RRC
	MOV	B,A		;Save sided flag in "B"
	LXI	H,SEKTYP	;Make into drive type with other info
	MOV A,M! ANI 38h	;Mask to select drive size bits
	ORA B!	MOV M,A
TREAD1:	LXI	H,RECAL		;Home to track 0
	MVI	B,LRECAL	;No status bytes for command
	CALL	MOVETO		;Process command, (Always reports success)
    if DISK1A
	JZ	TREAD3
	LDA	TEMPBF
	MOV	B,A
	ANI	FDC$SKE
	JZ	TRDX
	MOV	A,B
	ANI	FDC$CHK
	JZ	TRDX
	LXI	H,RECAL
	MVI	B,LRECAL
	CALL	MOVETO
	RNZ
TREAD3:	LDA	SEKTYP
	CPI	FD5TYPE
    endif
	MVI	A,2		;Seek to track two (only done if recal worked)
    if DISK1A
	JC	TREAD4
	MVI	A,4
    endif
TREAD4:	CALL DOSEEK!	RNZ	;Abort if error (not reported if not tried)
	LXI	H,DRID
	MVI	M,FD$DRID	;Get disk ID (format info)
TRD2:	PUSH	H
	LXI	B,(DRIDL*256)+7 ;Command length + 7 bytes of status
	CALL	EXEC		;Process command
	POP	H
	JZ	TRD3		;Get proper drive type if successful
	MOV A,M!  XRI FD$MFM	;Compliment MFM/FM bit
	MOV M,A!  ANI FD$MFM
	JNZ	TRD2		;Loop for MFM if read not valid
TRDX:	ORI	0FFh		;Abort if both FM and MFM tried and failed
	RET
;
TRD3:	LDA	TEMPBF+6	;Get number of bytes
	ADD A!	MOV B,A		;times 2 in "B"
	LDA  SEKTYP!	ORA B	;Combine N with sided flag
	STA  SEKTYP		;Save disk type
	CMP	A		;Set zero flag (show no error)
	RET
;
	PAGE
;----------------------------------------
;
;	READ SECTOR ROUTINE:
;
; Read a CP/M 128 byte sector (also known as a "record").
;
;Exit:	A = 0, Z bit set for successful read operation.
;	A = non-zero value if unsucessful read operation.
;
READ:	CALL	CHKBKD		;Check for blocked drive
	MVI	A,FD$RDAT	;Read from single density floppy
	JNC	FINAL		;If non-blocked transfer
	XRA	A		;Set flag to force a read
	CALL	FILL		;Fill buffer with data
	POP	H		;Host record address
	POP	D		;User DMA
	PUSH	PSW		;Save error status byte
	CALL	MOVDTA		;Move 128 bytes
	POP	PSW
	RZ			;Done if no error
;
;	HSTOFF - Turn off host active to prevent write to host.
; Used if error on fill to write buffer and if HOME command issued.
;
HSTOFF:	XRA	A		;Clear host active flag
	STA	HSTACT
	INR	A		;Indicate error condition
	RET
;
;	Check Blocked Disk transfer.
;
;Exit:	Carry bit set if blocked device.
;	Carry bit clear if unblocked device (logical and physical
;	sectors are both 128 bytes in length).
;
CHKBKD:	LDA	SEKTYP		;Get type of device in use
    if (XMDRIVE or HMDRIVE)
	CPI	MEMTYPE		;If M-drive
	RNC			;(not blocked)
    endif
    if (DISK2 or DISK3)
	CPI	D2$TYPE		;If Hard Disk
	CMC!	RC		;Always blocked if so
    endif
	ANI	06h		;See if 128 byte sector 8 or 5 inch
	RZ			;Not blocked device if so
    if FLOPPY5
	LDA	SEKTYP		;Get seek type again
	CPI FD5TYPE!  CMC!  RC	;Blocked if 5 1/4 inch, check track if 8"
    endif
	LDA	SEKTRK		;See if track 0, single density possible
	ADI	0FFh!	RC	;Blocked sectors if not track 0
	XRA	A		;Force type 0, reset blocked select bit
	STA	ACTTYP		;Use as actual type in use, non-blocked set
	RET
;
;----------------------------------------
;
;	WRITE SECTOR ROUTINE:
;
; Write the selected 128 byte CP/M sector.
;
;Entry:	C = 0, write to a previously allocated block.
;	C = 1, write to the directory.
;	C = 2, write to the first sector of unallocated data block.
;
;Exit:	A = 0, Z bit set for successful write operation.
;	A = non-zero value if unsucessful write operation.
;
WRITE:	XRA	A
	RET
;
;	FILL - fill host buffer with approprite host sector.
;
;Entry:	A = 0 means read physical sector required if not in buffer.
;	A = 0FFh means read not required.
;
;Exit:	On exit the stack will contain the following values:
;	POP	x = host record address.
;	POP	y = caller's buffer address.
;	A = 0 and Z-bit set if no errors occurred.
;
FILL:	STA	RDFLAG		;Save read flag
	LXI	H,HSTBUF	;Set DMA xfer to host buffer address
	SHLD	BUFADR
	LDA	SEKTYP		;Get disk type
    if (DISK2 or DISK3)
	CPI	D2$TYPE		;See if hard disk
	JNC	FILL1		;Use sector block size (log base 2) if so
    endif			;For both 8 inch and 5 1/4 inch floppies,
	RRC			;Put "N" field In the least significant bits
FILL1:	ANI	3		;Strip to get log base 2 of sector size
	MOV	B,A		;B = log base 2 (sector size) - 7
	XCHG			;Host buffer base in D,E
	LXI	H,128		;128 byte records
	LDA	SAVSEC		;Get logical sector (desired)
FILL2:	XCHG
	RRC			;Divide sector # by 2's to get physical
	JNC	FILL3		;If low bit not set
	DAD	D		;Add bias to offset
FILL3:	XCHG
	DAD	H		;Double significance of offset for next bit
	ANI	7Fh		;Mask to get physical sector
	DCR	B		;Bump log count for bit shifts
	JNZ	FILL2		;If not all bits checked
	STA	SEKSEC		;Physical sec # = desired / (sec size/128)
	LHLD	DMAADR		;Get DMA address from user
	XTHL			;Set return parameters
	PUSH	D		;Save host buffer pointer to 128 byte sector
	PUSH	H		;Set return address of user
	LXI	H,HSTACT	;Get current Host active flag
	MOV A,M! ORA A		;and it's status
	MVI	M,1		;which always becomes 1 (active)
	JZ	FILL6		;If host buffer was inactive, do a forced read
	LXI	H,HSTSEC-1	;Compare host values with desired
	LXI	D,SEKSEC-1
	MVI	C,SEKTYP-SEKSEC+1+1
FILL4:	INX H!	INX D		;Bump pointers for comparison
	XRA	A		;Clear error byte to zero value
	DCR C!	RZ		;Bump comparison count, done if all bytes match
	LDAX D!	CMP M		;See if current pair match
	JZ	FILL4		;Loop until all checked or mis-match
FILL6:	LHLD	SEKDSK		;Move disk and type
	SHLD	HSTDSK		;For new host physical read from disk
	SHLD	ACTDSK
	LHLD	SEKTRK
	SHLD	HSTTRK
	SHLD	ACTTRK
	LHLD	SEKSEC
	SHLD	HSTSEC
	SHLD	ACTSEC
	LDA	RDFLAG		;See if read required
	INR A!	RZ		;Done if not
;
RDMFM:	MVI   A,FD$RDAT+FD$MFM	;Read double density
;
;	FINAL  --  Perform final transfer processing, actual data
;	moved from/to memory to/from storage device.
;
;Entry:	A = Command, either READ or WRITE.
;
;Exit:	A = 0, Z-bit set if no errors occured during transfer with
;	a possibility of "MRTRY" retries at the transfer.
;	A = non-zero, Z-bit reset if errors occurred on all "MRTRY"
;	efforts at a transfer.
;
    PAGE
;
FINAL:	LXI	H,CIOPB		;Put the initial command in it's buffer
	MOV  M,A!	XCHG	;And save pointer in "D,E"
	LHLD	ACTTRK		;Get track (head, cylinder) number in "H,L"
	LDA  ACTSEC!  MOV C,A	;Get active sector number in "C"
	LDA	ACTTYP		;Get drive type in "A"
	XCHG			;Track in "D,E" and pointer in "H,L"
    if (DISK2 or DISK3)
	CPI	D2$TYPE		;See if hard disk type for drive
	JNC	HARDFNL		;Use it's controls if so
    endif
	INX	H		;Point to next buffer specification (drive)
    if FLOPPY5
	MOV	B,A		;Save type
	CALL	FIX58		;Set ports for 8 or 5 inch floppies
	MOV	A,B
    endif
	ANI	07h		;Remove mini-floppy select
	RAR			;Get N (sector size), reset carry if 1 sided
	MOV	B,A		;Save in "B"
	JNC	FPYFNL		;Done if single sided
	XRA	A		;Clear carry
	MOV	A,E		;Convert to head and cylinder (CY becomes head)
	RAR			;(divide by 2)
	MOV	E,A
FPYFNL:	MVI	A,0
	RAL			;Set head number bit from CY
	MOV	D,A		;Move to head field
	RLC!	RLC		;And head bit in drive # field
	MOV	M,A		;Save temporary value of head
	LDA	ACTDSK		;Get drive #
	ORA	M		;Combine head with drive
	MOV	M,A		;Set drive (0 0 0 0 0 HDS DS1 DS0)
	INX H!	MOV M,E		;+2 = Set cylinder
	INX H!	MOV M,D		;+3 = Set head
	INX H!	MOV A,C! INR A	;+4 = Set sector (+1 for controller)
	MOV	M,A		;Set beginning sector
	INX H! MOV A,B! MOV M,A	;+5 = Set N field
	INX H!	LDA NUMSEC	;+6 = Ending sector, calculated by N*2
	ADD C!	MOV M,A		;Set EOT
	INX H!	LDA ACTGPL	;+7 = Set Gap length
	MOV	M,A		;Set GPL field
	INX H!	MVI M,0FFh	;+8 = Set DTL to double density
	DCR B!	JP FNL0		;Use it if not single type (0)
	MVI	M,80h		;Set DTL to 128 bytes
FNL0:	MVI	E,MRTRY		;Set retry count in "E"
FNL1:	CALL	GTREADY		;Ask for drive status
	RNZ			;Abort if still not ready
	DCR E!	MOV A,E!  RM	;Bump retry count, done if negative status
	LDA	CIOPB+2		;Get cylinder number
	CALL	DOSEEK		;Seek to proper track
	JNZ	FNL1		;Retry if seek error
	LXI	H,BUFADE	;Load blocking/deblocking buffer as DMA address
	MVI	B,3		;24 bits (3 bytes)
FNL2:	MOV	A,M		;Get DMA address to controller
DMAPT:	OUT	FD8PORT+FDMA
	DCX H!	DCR B		;Data is backward in memory
	JNZ	FNL2		;Loop until all 3 bytes sent
	LXI	H,CIOPB		;Point to Command Input/Output Parameter Block
	LXI	B,(CIOPL SHL 8)+7 ;Set command length, get 7 status bytes
	CALL	EXEC1		;perform operation
	SUI	40h		;Remove "abnormal termination of command" bit
; -- This bit is set because at the end of the last sector read or written,
; there was no "Terminal Count" flag issued from an external DMA controller.
; On the DISK 1 this signal is grounded, and although the FDC indicates this
; error, if the "End of Track Encountered" error bit is also set and no others
; are, this represents a successful read or write by the DISK 1.
	JNZ	FNL1		;Try again if any other error
	LDA	TEMPBF+1	;Get second result status byte
	SUI	FD$EOC		;Remove sector past end of cylinder bit
	RZ			;Done if no other errors
	JMP	FNL1		;Loop if not write error
;
;	GTREADY - Wait until selected drive is ready or console driven abort
;		 (any char typed).
;
;Exit:	Z-bit set if drive is ready, or was made ready after request.
;	Z-bit reset if console abort -- drive not ready.
;
  if DISK1
GTREADY:MVI	A,0F0h		;Turn on drives
FDCMOT:	OUT	FD8PORT+FDON	;Serial port used as "motor on" control bit
	CALL	GTDSTS		;Ask for drive status, ignore first reading
	CNZ	GTDSTS		;Ask again if first reading didn't show ready
	RZ			;Done if ready
	LXI	H,NRDYM1	;Show not ready
	CALL	PRINT
GTRDY1:	CALL	GTDSTS		;Get drive status
	RZ			;Done if now ready
	CALL	CIS		;See if character at console (abort)
	JZ	GTRDY1		;Loop until console abort or drive ready
	RET
  endif
  if DISK1A
    if (FLOPPY5 or MOTOR8)
GTREADY:
    endif
    if (MOTOR5 or MOTOR8)
	MVI	A,0F0H
	OUT	FD8PORT + FDON
    endif
    if not MOTOR8
	LDA	ACTTYP
	CPI	FD5TYPE
	JC	GTRDY1
    endif
MAKRDY:
    if not READY5
	CALL	SOFTRDY
	MOV	A,B
	ORA	C
	JZ	NOTRDY
    endif
    if READY5
      if not (FLOPPY5 or MOTOR8)
GTREADY:
      endif
    endif
GTRDY1:	CALL	GTDSTS
	CNZ	GTDSTS
	RZ
    if not READY5
      if (MOTOR5 or MOTOR8)
;	MVI	A,0F0H
;	OUT	FD8PORT + FDON
	LDA	ACTTYP
	CPI	FD5TYPE
       if MOTOR5
	JNC	MAKRDY
       endif
       if MOTOR8
	JC	MAKRDY
       endif
      endif
    endif
;
NOTRDY:	LXI	H,NRDYM1
	CALL	PRINT
GTRDY2:
    if not READY5
      if (MOTOR5 or MOTOR8)
	CALL	SOFTRDY
	MOV	A,B
	ORA	C
	JZ	GTRDY3
      endif
    endif
	CALL	GTDSTS
	RZ
GTRDY3:	CALL	CIS
	JZ	GTRDY2
	RET
;
;	SOFTRDY -- Get drive ready status by samplint the INDEX pulse status
;	bit directly associated with the desired drive.  5-1/4 inch drives
;	often don't have a normal READY line, but it can be simulated by
;	testing for two consecutive index pulses from the selected drive.
;	This is also necessary for utilizing motor on/off control with 8-inch
;	drives, since their ready line will remain unchanged if the motor is
;	stopped with the diskette remaining in the drive.  This routine
;	verifies both that a diskette exists in the selected drive, and that
;	it is rotating at speed.
;
;Exit:	BC = 0 if the selected drive "timed out" without an index pulse
;	  appearing within approximately one second.
;
    if not READY5
SOFTRDY:MVI	A,0F0H
	OUT	FD8PORT + FDON
	LDA	ACTDSK
	ORI	FDXUS
	OUT	FD8PORT + FDCS
	LXI	B,4000H
SFTRDY1:MVI	D,10
SFTRDY2:XTHL
	XTHL
	DCR	D
	JNZ	SFTRDY2
	IN	FD8PORT + INTS
	ANI	FDINDEX
	JNZ	SFTRDY3
	DCX	B
	MOV	A,B
	ORA	C
	JNZ	SFTRDY1
SFTRDY3:MOV	A,B
	ORA	C
	JZ	SFTRDYX
SFTRDY4:MVI	D,25
SFTRDY5:XTHL
	XTHL
	DCR	D
	JNZ	SFTRDY5
	IN	FD8PORT + INTS
	ANI	FDINDEX
	JZ	SFTRDY6
	DCX	B
	MOV	A,B
	ORA	C
	JNZ	SFTRDY4
SFTRDY6:MOV	A,B
	ORA	C
	JZ	SFTRDYX
SFTRDY7:IN	FD8PORT + INTS
	ANI	FDINDEX
	JZ	SFTRDY7
SFTRDYX:PUSH	B
	LDA	FIXMASK
	OUT	FD8PORT + FDCS
	LXI	B,1
	CALL	FIXWAIT
	POP	B
	RET
;
    endif
;	FIXWAIT -- delay approximately one millisecond
FIXWAIT:MVI	A,(CPUSPD*1000)/26
FIXDLY:	INX	B
	DCX	B
	DCR	A
	JNZ	FIXDLY
	DCX	B
	MOV	A,B
	ORA	C
	JNZ	FIXWAIT
	RET
  endif
;
;	DOSEEK -- Seek to specified Track:
;
;Entry:	A = Track number to seek to.
;
DOSEEK:	STA	DSEKC+2		;Save cylinder #
	LXI	H,DSEKC		;Seek command pointer
	MVI	B,DSEKL		;Seek command with no status bytes recieved
;
;	MOVETO -- Move head according to command:
;
;Entry:	H,L = address of command buffer.
;	B = length of command buffer.
;
;Exit:	Z-bit set if no error.
;
MOVETO:	CALL	EXECP		;Set up seek command in controller
SEEKI:	CALL	INTREQ		;Wait for interrupt service request
	MVI	A,FD$RSTS	;Send Request for interrupt status command
FDCD0:	OUT	FD8PORT+FDCD
	MVI	C,2		;2 status bytes recieved
	CALL	GCMPS		;Get status
	SUI  FDC$SKE!	RZ	;Verify seek end, no other errors -- done if so
	LDA	ACTDSK		;See if disk sampled matches
	XRA M!	ANI 3		;One in status byte
	JNZ	SEEKI		;Loop until so
	INR	A		;Show error
	RET
;
;	GTDSTS	- Get drive ready status of ACTDSK:
;
;Exit:	Z-bit set if ready.
;
GTDSTS:	LXI	H,DSTS		;Ask for drive status
	MVI	B,DSTSL		;Command length and 1 status byte
	CALL	EXECP		;Perform command
	INR	C		;Get 1 status byte
	CALL	GCMPS
	CMA			;Flip polarity of status byte
	ANI	FD$RDY		;Mask ready bit
	RET
;
;	EXEC, execute normal floppy disk controller command sequence:
;	EXECP, execute floppy disk controller command sequence with no
;	status check afterwards ("C" = 0):
;
;Entry:	H,L = Pointer to first byte of command buffer,
;	B  = number of bytes to output to controller in sequence,
;	C  = number of bytes to input to status buffer.
;
;Exit:	If C <> 0 then see GCMPS.
;	H,L = 1 past last byte of command buffer if no status bytes.
;	C = 0 on exit always.
;
EXECP:	MVI	C,0		;No status bytes for this execution
EXEC:	INX	H		;Point to drive # byte
	LDA	ACTDSK		;Set drive into command buffer
	MOV	M,A		;at second byte
	DCX	H		;Point to start of command sequence
EXEC1:	CALL	GETRQM		;Wait for request for master service
	MOV	A,M		;Get command byte
FDCD1:	OUT 	FD8PORT+FDCD	;Send to controller
	INX H!	DCR B		;Point to next
	JNZ	EXEC1		;Loop if more bytes
	MOV	A,C		;# of status bytes
	ORA A!	RZ		;Done if no status bytes
;
; Command Phase completed, now wait for Execution Phase completion indication.
	CALL	INTREQ		;Wait for interrupt service request
;
;	Get result status byte(s) into TEMPBF buffer.
;
;Entry:	C = number of Result Phase status bytes to read.
;
;Exit:	H,L = TEMPBF = pointer to status bytes read in.
;	A = first status byte anded with 0F8h with flags set accordingly.
;
GCMPS:	LXI	H,TEMPBF	;Set status buffer address
	PUSH	H		;Save status buffer start pointer
GCMPS2:	CALL	GETRQM		;Wait for request for master service
FDCD2:	IN	FD8PORT+FDCD	;Read result status byte
	MOV M,A!  INX H		;In status buffer, point to next location
	DCR	C		;Decrement status byte counter
	JNZ	GCMPS2		;Wait until all done
	POP	H		;Point to first status byte
	MOV	A,M		;Get first status byte
	ANI not (FD$HDS + FD$DRVS) ;Get completion status less drive, head bits
	RET
;
; Poll for RQM status bit, done when master requests service.
GETRQM:
FDCS1:	IN	FD8PORT+FDCS	;Get main status byte
	ORA	A		;See if request for master service bit set
	JP	GETRQM		;Loop if not ready
;	ANI	FD$DIO		;Mask data direction (DIO) bit
	RET
;
; Wait for Interrupt Service Request from FDC (8272).
INTREQ:
INTS1:	IN	FD8PORT+INTS	;Get interrupt status byte
	ORA	A		;Sample interrupt service request bit
	JP	INTREQ		;Wait for interrupt if not set
	RET
;
;	Self modifying code to fix ports for 8 or 5 inch disk controller.
;
  if FLOPPY5
FIX58:
    if DISK1
	CPI	FD5TYPE		;See if 8 inch drive selected
	MVI	A,FD8PORT
	JC	FIXPORT
FIX5:	MVI	A,FD5PORT	;Use 5 1/4 inch controller if not
FIXPORT:STA	FDCS1+1		;Fix control/status ports to correspond
	INR	A
	STA	FDCD0+1		;Data ports
	STA	FDCD1+1
	STA	FDCD2+1
	INR	A
	STA	DMAPT+1		;DMA port as output
	STA	INTS1+1		;Status as input
	INR	A
	STA	FDCMOT+1	;Motor on control port (bit banger unused)
	RET
    endif
    if DISK1A
	PUSH	B
	PUSH	D
	PUSH	H
	ANI	FD5TYPE
	MOV	B,A
	LDA	FIXTYPE
	CMP	B
	MOV	A,B
	STA	FIXTYPE
	JZ	FIX58X
      if MOTOR5 or MOTOR8
	MVI	A,0F0H
	OUT	FD8PORT + FDON
      endif
	LDA	ACTDSK
	ANI	3
	RLC
	MOV	C,A
	MVI	B,0
	LXI	H,SPECTBL
	DAD	B
	MOV	A,M
	INX	H
	MOV	H,M
	MOV	L,A
	MOV	A,M
	INX	H
	STA	FIXMASK
	OUT	FD8PORT + FDCS
	LXI	B,1
	CALL	FIXWAIT
	LXI	B,(3*256)+0
	CALL	EXEC1
	LXI	B,240
	CALL	FIXWAIT
FIX58X:	POP	H
	POP	D
	POP	B
	RET
    endif
  endif
;
	PAGE
;****************************************************************
;*	FINAL PROCESSING FOR HARD DISK DRIVES (DISK 2,3)	*
;****************************************************************
;
;	Routines for driving the DISK2 and DISK3 controllers, and drives
; corresponding SELECTOR CHANNEL boards if DISK2 in conjunction
; with one to four hard disk drives.
;
HARDFNL:
    if (DISK2 and DISK3)
	CPI	D3$TYPE		;See if DISK3 driver
	JC	D2$FNL		;Finish with DISK2 if not
    endif
    if DISK3
D3$FNL:	LXI	H,D3CIOPB+2	;Point to DISK3 command parameter block
	LDA  ACTDSK!	MOV M,A	;Setup active disk as 0-3 selection of drive
	LDA	CIOPB		;Get original command
	CMA!	ANI 1		;Correct for DISK3 read/write control bit
	INX H!	MOV M,A		;Save Read/Write command type
	INX H!	MOV M,C		;Save lower half of sector count
	INX H!	XRA A!	MOV M,A	;Upper half is zero
	INX H!	MOV M,E		;Save track lower half
	INX H!	MOV M,D		;and upper track half
	INX H!	MVI M,1		;Transfer 1 sector
	INX H!	MOV M,A		;Upper half is zero
	XCHG!	LHLD BUFADR	;Get local DMA address
	XCHG!	INX H!	MOV M,E	;Lower byte saved
		INX H!	MOV M,D	;Middle byte saved
	LDA	BUFADE		;Get upper byte
		INX H!  MOV M,A	;Upper byte saved to complete command load
; Linkage remains fixed to loop back to start of D3CIOPB
	MVI	A,D3$XFER	;Set up for data Input/Output transfer
D3EXEC:	LXI	H,D3CIOPB	;Point to parameter block in use
D3EXEC0:MOV	M,A		;Put command in first byte of parameter block
	INX H!	MVI M,0		;Clear the status byte
; Begin command execution, wait for result status.
	MVI	A,D3$ATTN	;Issue "attention" command to DISK3 to start
	OUT	D3$PORT		;Disk controller operation
D3EXEC1:MOV A,M! ORA A		;See if command execution has completed
	JZ	D3EXEC1		;Loop for status test if not
	INR A!	RZ		;See if result was 0FFh (valid completion)
	ADI	'0'-1		;Add ASCII bias for error type
	STA	D3MSG2
	PUSH B!	PUSH D!	PUSH H
	LXI	H,D3MSG		;Show error message and type
	CALL	PRINT
	CALL	CI		;Wait for operator to respond
	POP H!	POP D!	POP B
	ORI	0FFh		;Show error condition on return
	RET
;
   endif
;
	PAGE
;********************************************************
;*	FINAL PROCESSING FOR DISK 2 HARD DISK DRIVES 	*
;********************************************************
;
    if DISK2
D2$FNL:	MOV	A,E		;Get low order portion of track
	XCHG			;Put desired track number in "H,L"
	DAD H!	DAD H		;Shift left 4 bits to put cylinder in "H"
	DAD H!	DAD H
;     if (D2M??)		;16 heads
;	ANI	0000$1111b	;Select head value (0-15)
;     endif
      if (D2M20 or D2F40B or D2M26) ;8 heads
	ANI	0000$0111b	;Select head value (0-7)
	DAD	H	;Shift left (6 bits) again for proper cylinder in "H"
      endif
      if (D2M10 or D2F20B)	;4 heads
	ANI	0000$0011b	;Select head value (0-3)
	DAD H!	DAD H		;Shift left again for proper cylinder in "H"
      endif
	MOV	L,A		;Put head value in "L"
	XCHG			;Return both to "D,E" - command pointer "H,L"
	MOV A,M!  ANI 1		;Select Read/Write bit from floppy command
	MVI	M,D2$READ	;Replace with hard disk read
	JZ	D2FNLX		;if was a floppy read command
	MVI	M,D2$WRT	;Use write command instead if not
D2FNLX:	MVI	L,MRTRY		;Load max retry count
D2FNLP:	DCR L!	MOV A,L!  RM	;Bump retry count, done if neg (0FFh) status
	CALL	D2SELECT	;(Re-)select appropriate drive, verify ready
	RNZ			;Abort if not
	PUSH	H		;Save retry counter on stack
	CALL	D2XFER		;Seek to proper cylinder, perform data transfer
	POP	H		;Recover retry counter
	RZ			;Done if no errors
	ADD	A		;See if timeout error (header not found)
	JP	D2FNLP		;Loop in case of soft error (not timeout)
;
;	D2RELOCATE -- Search relocation table for matching sector ID, load
;	corresponding relocated sector values if found and try transfer
;	again using alternate sector.
;
D2RELOC:RRC			;Restore error byte
	ANI	D2$OVR		;See if overrun was cause of timeout
	JNZ	D2FNLP		;Treat as soft error if so
	LXI  H,(RELTBL0 - 2) - (3 * D2$SCNT)
;	    Point to base of relocation table(s), pre-comp for 2 indexes
	PUSH	D		;Save head, cylinder specification
	LXI	D,(3 * D2$SCNT)	;Point to next disk unit's faulty sector table
D2REL1:	DAD	D		;Add unit table size until correct one found
	DCR	B		;Bump unit number count
	JP	D2REL1		;Loop until pointer at this unit's table
	POP	D		;Recover head, cylinder specification
;
; Loop entry points -- if no match found, skip other tests for match of
; current head, sector and advance to next 3 byte entry in table.
D2REL5:	INX	H		;Skip head storage byte
D2REL4:	INX	H		;Skip sector storage byte
D2REL3:	MVI	A,D2$SCNT-1	;See if all available spare sectors checked
	INR B!	CMP B		;Bump count of table entries, see if past max
	RC			;Irrecoverable error if no entries match
	MOV A,M!  INX H!  CMP D	;See if CYLINDER matches table
	JNZ	D2REL5		;Skip head, sector check if not
	MOV A,M!  INX H!  CMP E	;See if HEAD number matches table
	JNZ	D2REL4		;Skip sector check if not
	MOV A,M!  INX H!  CMP C	;See if SECTOR matches table
	JNZ	D2REL3		;See if scan next triplet if not
;
; Place new values in the registers to correspond with the relocated sector,
; and continue with the Disk 2 read/write operation using the "spare" storage.
D2XRELS:MOV	C,B		;Corresponding sector number counted in "B"
	LXI	D,2		;Relocated sectors at cylinder 0, head #2
	JMP	D2FNLX		;Continue with execution using new values
;
;	D2SELECT -- Select appropriate DISK 2 hard disk drive.
;
;Entry:	ACTDSK set to current active drive to get ready status.
;
;Exit:	C,D,E unaltered,
;	B = Lower nibble of drive select (0-3) from ACTDSK value,
;	Zero bit set if drive is ready.
;
D2SELECT:CALL	D2READY		;See if drive is ready, ignore first if not
	CNZ	D2READY		;Reset drive fault bit, again check drive ready
	RZ			;Return valid if so
	PUSH B!	PUSH D!	PUSH H	;Save desired positions
	LXI	H,D2$MSG	;Show unit not ready
	CALL	PRINT
D2SEL1:	CALL	CIS		;See if character from console
	JNZ	D2SEL2		;Return with zero bit reset (error) if so
	CALL	D2READY		;See if drive is ready
	JNZ	D2SEL1		;Keep trying until so or console abort
D2SEL2:	POP H!	POP D!	POP B	;Recover desired positions
	RET
;
; Routine to get the drive ready status of the active hard disk.
D2READY:LDA	ACTDSK		;Get unit select (upper and lower nibbles set)
	ANI 3!	MOV B,A		;Select lower nibble in range 0-3, save in "B"
	ORI (D2$STRB + D2$RST)	;Add in drive strobe, fault clear bits
	OUT	D2$CNTL		;Set drive select register
	ADI '0'-(D2$STRB+D2$RST);Add bias and save as drive ASCII ID
	STA	D2$MSGX		;in error message
	LDA	ACTDSK		;Get unit select (upper and lower nibbles set)
	ANI	1111$0000b	;Use only upper nibble single select
	OUT	D2$DATA		;Set up DISK 2 with drive select
	IN	D2$STAT		;Get status byte
	ANI (D2$ATTN + D2$NRDY)	;Strip out attention, drive ready bits
	XRI	D2$ATTN		;Flip status of attention bit
	RET			;Return with drive ready status
;
;	D2XFER - DISK 2 Data Transfer (to/from Hard Disk) Operation.
;
; -- Two part transfer (with seek to home position if cylinder unknown).
; First the command sequence is given to seek correct cylinder, and for drives
; having automatic settling time delays, the concurrent loading of the
; controller to execute the actual data transfer.  For drives not having an
; automatic settling time delay, the No-op command is issued after a seek,
; which allows between 1 and 2 extra revolutions of the disk to allow the
; heads to settle.
;
;Entry:	CIOPB = command, (read or write)
;	D = Desired cylinder to seek,
;	E = Desired head of cylinder,
;	C = Desired sector of track,
;	B = Actual disk unit in use.
;
;Exit:	B,C,D,E unaltered,
;	H,L = Pointer to current cylinder table storage,
;	Zero bit set if no errors occurred.
;
D2XFER:	LXI	H,HD2CYL	;Base address of last known cylinder positions
	PUSH	B		;Get this drive's
	MOV C,B!  MVI B,0	;Offset for last cylinder position in "B,C"
	DAD B!	POP B		;Add offset for desired drive unit number (0-3)
	MOV	A,M		;Get last position for active unit
	CPI	-1		;Minus one indicates unknown -- seek home
	CZ	D2HOME		;Execute sequence if "forced" home
				;Current cylinder again (after home) in "A"
	SUB	D		;Get the difference of desired and current
	CNZ	D2SEEK		;If current not at desired cylinder, seek to it
;
; DISK 2 Transfer data to/from hard disk.
	PUSH	H		;Save cylinder pointer
	MVI	A,D2$STRB	;Add drive select command
	ORA	B		;to unit desired
	OUT	D2$CNTL		;Output to DISK 2 control register
	LDA	ACTDSK		;Get active drive number
	ANI	1111$0000b	;Mask single select bits (high nibble)
	ORA E!	  OUT D2$DATA	;Select drive, head
	MVI	A,D2$CYL	;Select cylinder number storage
	OUT	D2$CNTL
	MOV A,D!  OUT D2$DATA	;Get desired Cylinder number
	MVI	A,D2$HEAD	;Select head number storage
	OUT	D2$CNTL
	MOV A,E!  OUT D2$DATA	;Get the desired Head number
	MVI	A,D2$SEC	;Select sector storage
	OUT	D2$CNTL
	MOV A,C!  OUT D2$DATA	;Load desired sector
;
; Set up selector channel to correspond, with desired DMA value ready.
	IN	SELCHAN		;Initialize selector channel to accept data
	LXI	H,BUFADE	;Get extended DMA address byte
	MOV A,M! DCX H		;from storage, point to middle byte
	OUT	SELCHAN		;Upper byte Loaded first
	MOV A,M! DCX H		;Load with remaining DMA mid, low bytes
	OUT	SELCHAN
	MOV A,M			;For full 24 bit DMA transfer address
	OUT	SELCHAN
	LDA	CIOPB+0		;Get hard disk Read/Write command
	CPI	D2$READ		;See if read operation
	PUSH	PSW		;Save Read/Write operation type
	MVI	A,SELBYT+00h	;Upper bit not set if write operation
	JNZ	D2XFER4
	MVI	A,SELBYT+80h	;Set up selector channel to correspond
D2XFER4:OUT	SELCHAN		;Last byte of 4 in sequence
	POP PSW!  ORA B		;Get read/write command that begins transfer
	OUT	D2$CNTL		;Send to controller to begin execution
	XTHL!	XTHL		;Let the state machine start it's sequence
; Loop until command completed.
D2XFER5:IN	D2$STAT		;Get status of controller
	ORA	A		;See if command still in process
	JM	D2XFER5		;Loop until transfer complete
	ANI (D2$TOUT + D2$CRC + D2$OVR + D2$NRDY + D2SEKD + D2$WRTF)
; Select Timeout, CRC error, Overrun, Not Ready, Seek Done, Write Fault* bits
	XRI	D2$WRTF		;Flip status of write fault bit for final
	POP	H		;Recover table pointer for cylinder updates
	PUSH	PSW		;Save error status
	MVI	A,D2$STRB	;Reset interrupt status bit to inactive state
	OUT	D2$CNTL
	MVI	A,0001$0000b	;Reselect Unit #0 to execute command
	OUT	D2$DATA
	POP	PSW!	RZ	;Done if no errors from transfer operation
	MVI	M,0FFh		;Show drive at unknown position, force home
	RET			;Return with error type set
;
;	D2SEEK -- DISK 2 Execute seek to desired cylinder position.
;
;Entry:	H,L = Pointer to current cylinder table storage,
;	D = Desired cylinder to seek,
;	E = Desired head of cylinder,
;	C = Desired sector of track,
;	B = Actual disk unit in use.
;
;Exit:	B,C,D,E,H,L unaltered, return when desired cylinder has been reached.
;	Storage for unit positioner [H,L] updated, indicating new location.
;
D2SEEK:	PUSH	D		;Save head, cylinder numbers
	MVI	E,D2$SOU	;Seek outward control byte
	JNC	D2SEEKO		;If seek outward
	MVI	E,D2$SIN	;Seek inward control byte
	CMA!	INR A		;Two's compliment count to make positive
D2SEEKO:MOV	D,A		;Move number of tracks
	MOV A,B! ORA E		;Get selected drive, add in step direction
	OUT	D2$CNTL		;Send to DISK2
	XTHL!	XTHL		;Allow the direction bit to settle
D2STEP1:IN	D2$DATA		;Activate a step
      if (D2M10 or D2M20 or D2F20B or D2F40B) ;All steps accumulated by drive
	DCR	D		;Bump step counter
	JNZ	D2STEP1		;If not all steps sent
	POP	D		;Recover desired cylinder
	MOV	M,D		;Set current storage = desired
      else			;Steps are issued individually
D2SEEK2:IN	D2$STAT		;Get drive status
	ANI	D2$SEKD		;See if seek complete
	JNZ	D2SEEK2		;Wait until so
	DCR	D		;Bump step counter
	JNZ	D2STEP1		;Loop for another if not all steps sent
	  if D2M26		;Shugart drive requires computed settling time
	MVI	A,D2$TIME	;Issue a NO-OP command to get settling delay
	ORA	B		;Add in selected unit control bits
	OUT	D2$CNTL		;Send to controller, use next instructions for
				; command settling delay (no interrupt active)
	POP	D		;Recover desired cylinder
	MOV	M,D		;Set current storage = desired
D2SKDLY:IN	D2$STAT		;Get controller status byte
	ANI	D2$TOUT		;Mask timeout bit (1-2 index pulse delay)
	JZ	D2SKDLY		;Loop for settling time (approx.) till timeout
	  else			;No extra delay necessary
	POP	D		;Recover desired cylinder
	MOV	M,D		;Set current storage = desired
	  endif
      endif
	RET
;
;	D2HOME -- DISK 2 Execute seek to Home position (cylinder #0).
; This routine is called when the actual position of a drive unit (as measured
; by it's cylinder number) is in doubt.  It returns the positioner to the
; special "known" place at the outermost cylinder.
;
;Entry:	H,L = Pointer to current cylinder table storage,
;	B = Actual disk unit in use.
;
;Exit:	B,C,D,E,H,L unaltered, return when cylinder 0 has been reached,
;	A = 0, and storage for unit (H,L pointer) reset, indicating proper
;		location of positioner.
;
D2HOME:	INR	M		;Mark current with proper "home" value (zero)
	PUSH B!	MOV C,M		;Save sector, use 256 count in "C"
D2HOME0:IN	D2$STAT		;Get drive status
	ANI	D2$CYL0		;See if cylinder 0 has been reached
	JZ	D2HOME3		;Done with seek operation if so
	MOV	A,B		;Get active drive unit
	ORI (D2$SOU + D2$RST)	;Add in step out command, reset fault bit
	OUT	D2$CNTL		;Send to DISK2
D2HOME1:IN	D2$DATA		;Cause a step to be activated
	DCR	C		;Bump step counter
      if (D2M10 or D2M20 or D2F20B or D2F40B)
				; Fujitsu drives accept all pulses at once
	JNZ	D2HOME1		;Loop if not done with steps
      endif
D2HOME2:IN	D2$STAT		;Get drive status
	ANI	D2$SEKD		;See if seek complete
	JNZ	D2HOME2		;Wait until so
      if D2M26			;Shugart drives require separate pulses
	JMP	D2HOME0		;Loop if not done with steps
      endif
D2HOME3:POP	B		;Recover desired sector, active unit
	MOV	A,M		;Get current cylinder again (after home) in "A"
	RET
    endif
;
;	MOVDTA	- Move data (128 bytes) in memory.
;
;Entry:	H,L = Source address,
;	D,E = Destination address,
;	A   = Source / Destination extended address byte (direction dependent).
;
    if z80
MOVDTA:	LXI	B,128		;128 bytes to move
	DB 0EDH,0B0H	;LDIR	;Perform move
	RET
    else
MOVDTA:	MVI	B,128		;128 bytes to move
MOVE1:	MOV A,M! STAX D		;Get source byte, save in destination
	INX H!	INX D		;Point to next in each
	DCR	B		;Byte count
	JNZ	MOVE1		;Loop until done
	RET
    endif
	PAGE
;
;	PRINT -- Print message terminated by zero byte:
;Entry:	H,L = message pointer, terminated by NULL character.
;Exit:	H,L = zero byte + 1.
;
PRINT:	PUSH	H		;Save string pointer
	MVI	C,CR		;Xmit a carriage return
	CALL	CO		;Output to the console
	MVI	C,LF		;Followed by a line feed
	POP	H		;Recover string pointer
PRINT1:	PUSH	H		;Save string pointer
	CALL	CO		;Output to the console
	POP	H		;Recover string pointer
	MOV A,M! INX H		;Get a character, point to next
	ORA A!	RZ		;If zero (NULL), then terminate
	MOV	C,A
	JMP	PRINT1		;Loop until "NULL" encountered in string
;
;	Drive error messages altered to indicate the drive (unit) in question.
;
NRDYM1:	DB	'Load Drive '
NRDYM2:	DB	'x:',CR,LF,0
;
    if DISK1A
FIXTYPE:DB	-1
FIXMASK:DB	0
;
SPECTBL:DW	SPEC8
	DW	SPEC8
	DW	SPEC5
	DW	SPEC5
;
SPEC8:	DB	0
	DB	FD$SPEC
	DB	(SRT8 shl 4) + HUT8
	DB	HDLT8 shl 1
;
SPEC5:	DB	FD5SL+FDF2S
	DB	FD$SPEC
	DB	(SRT5 shl 4) + HUT5
	DB	HDLT5 shl 1
    endif
;
    if DISK2
D2$MSG:	DB	'DISK2 Unit #'
D2$MSGX: DB	'x Not Ready',0
    endif
;
    if DISK3
D3MSG:	DB	'DISK3 Error #'
D3MSG2:	DB	'x',0
    endif
;
	PAGE
;************************************************
;*	CONSOLE,READER,PUNCH,LIST ROUTINES	*
;************************************************
;
;	CONSOLE STATUS INPUT ROUTINE:
;
;Exit:	A = 0 (zero), means no character currently ready to read.
;	A = FFh (255), means character currently ready to read.
;
CONST:	MVI	A,7		;Console defaults to Interfacer 3,4 USER 7
	OUT	IF3UX		;Select mux
BCON1:	IN	IF3US		;Get device status
	ANI	UDAV		;Mask data available
	RZ			;Return if not
LISTST:	ORI	0FFh		;Show ready
	RET
;
;-------------------------------
;
;	CONSOLE DATA INPUT ROUTINE:
;
; Read the next character into the A register, clearing
; the high order bit.  If no character currently ready to
; read then wait for a character to arrive before returning.
;
;Exit:	A = character read from terminal.
;
CONIN:
READER:
	CALL	CONST		;See if character is ready
	JZ	CONIN		;Wait until so
BCON2:	IN	IF3UD		;Get data
	ANI	7Fh		;Strip off parity
	RET
;
;-------------------------------
;
;	CONSOLE DATA OUTPUT ROUTINE:
;
; Send a character to the console.  If the console is not ready
; to output a character, wait until it is, then do transmission.
;
;Entry:	C = ASCII character to output to console.
;
CONOUT:
PUNCH:
LISTOUT:
	MVI	A,7		;Console defaults to Interfacer 3,4 USER 7
	OUT	IF3UX		;Select mux
CONOUT2:
BCON3:	IN	IF3US		;Get device status
	ANI	UTBE		;Mask TBE, DSR bits
	XRI	UTBE		;Toggle both
	JNZ	CONOUT2		;Loop until ready
	MOV	A,C		;Get character to transmit to 'A'
BCON4:	OUT	IF3UD		;Send data
	RET
;
;-------------------------------
;
	PAGE
;************************************************
;*	INITIALIZED VARIABLES / CONSTANTS	*
;************************************************
;
;	BIOS blocking / deblocking flags.
;
HSTACT:	DB	0	;Host active flag
HSTWRT:	DB	0	;Host written (must follow host active flag)
RDFLAG:	DB	0	;Read flag
;
;	Floppy Disk commands followed by data storage bytes.
;
DSEKC:	DB	FD$SEEK,0,0	;Seek track command
DSEKL:	EQU	$-DSEKC
;
DSTS:	DB	FD$DSTS,0	;Get drive status command
DSTSL:	EQU	$-DSTS
;
RECAL:	DB	FD$RECA,0	;Recalibrate (seek to home track) command
LRECAL:	EQU	$-RECAL
;
DRID:	DB	FD$DRID,0	;Read disk ID command to get sector size
DRIDL:	EQU	$-DRID
;
;	Disk 2 track location storage (not retained by controller).
;
    if DISK2
HD2CYL:	DB	-1,-1,-1,-1	;Show all 4 possible drives in unknown
    endif			;positions (force home operation).
	PAGE
;****************************************
;*	WARM AND COLD BOOT ROUTINES	*
;****************************************
;
;	BOOT CP/M FROM SPECIFIED DISK:
;
; The CBOOT entry point gets control from the cold start loader and
; is responsible for the basic system initialization.  This includes
; outputting a sign-on message and initializing the following page
; zero locations:
;
;    0,1,2: Set to the warmstart jump vector.
;        3: Set to the initial IOBYTE value.
;        4: Default and logged on drive.
;    5,6,7: Set to a jump to BDOS.
;
;Exit:	Register C must contain the selected drive, which is
;	zero to select the "A:" drive.  The exit address is to
;	the CCP routine.
;
;	The WBOOT entry point gets control when a warm start occurs,
; a ^C from the console, a jump to BDOS (function 0), or a jump
; to location zero.  The WBOOT routine reads the CCP and BDOS 
; from the appropriate disk sectors.  WBOOT must also re-initialize
; locations 0,1,2 and 5,6,7.  The WBOOT routine exits with the "C"
; register set to the appropriate drive selection value.  The exit
; address is to the CCP.
;
WBOOT:	LXI	SP,100h		;Temp stack for boot
	LXI	H,CCP+3		;The "+3" allows warm boot and go to
	PUSH	H		;CP/M with no buffer execution
;
;	CCP can be loaded with name of program to execute if vector
; to just "CCP".  This is used at end of cold boot to load any extra
; routines to the CBIOS (such as interrupt handlers), and may be a
; SUBMIT file which does many things.
;
	CALL	LOADCPM		;Boot CP/M from floppy or hard disk
GOCPM:	LXI	B,80h		;Set default data transfer address
	CALL	SETDMA
	MVI	A,0C3h		;Store jumps in low memory
	STA	0		;CBIOS vector
	STA	5		;BDOS vector
	LXI	H,BIOS+3	;Warm boot vector address
	SHLD	1
	LXI	H,X$BDOS	;BDOS vector address
	SHLD	6
	LDA	CDISK		;Get active warm boot disk #
	MOV	C,A		;Put in "C" for CP/M
	RET
;
	BOOTCPM		;Boot CP/M from disk, exit only if load sucessful.
;
	PAGE
REUSE:	SET	$	;Start of re-usable space
;************************************************
;*	COLD BOOT INITIALIZATION ROUTINES	*
;************************************************
;
;	Initial Console I/O setup table:
;Format:	Status,Data	I/O ports
;
CON$TBL:DB	IF1US0,IF1UD0	;Interfacer I, port 0
	DB	SS1US,SS1UD	;System Support I
	DB	SS1US,SS1UD	;System Support I
	DB	IF3US,IF3UD	;Interfacer 3,4 (usually "user 7")
;
CBOOT:	LXI	SP,100h		;Temp stack for cold boot
	LHLD	BOOTSW		;Get Boot Switch value
	DAD H!	MVI H,0		;Times 2 in "H,L"
	LXI	D,CON$TBL	;Add to console I/O device status, data table
	DAD D!	MOV A,M
	STA	BCON1+1		;Set input status port from table
	STA	BCON3+1		;Set output status port
	INX H!	MOV A,M		;Set console I/O Data ports as well
	STA	BCON2+1		;Set input data port
	STA	BCON4+1		;Set output data port
;
; Print the corrected sign-on message to the default console.
	LXI	H,SIGNON	;Show outside world that we're alive
	CALL	PRINT		;Output Banner
    if DISK3
	CALL	D3INIT		;Initialize the DISK3 controller
    endif			;(before a boot if done there)
;
; Perform the cold boot from disk operation to bring in CP/M.
	CALL	LOADCPM		;Get CP/M into memory
;
; Load up the sector relocation tables for the hard disk systems.
    if DISK2		;Hard disk unit active (#0)
	LXI	H,RELTBL0	;Point to relocation table storage
	MVI	C,D2UNIT0	;Get Unit #0 ID
	CALL	D2INIT		;Read in table to initialize memory
    endif
;
	XRA	A		;Always set the default disk to drive A: on
	STA	CDISK		;cold boot entry to CP/M (or SUBMIT won't work)
	CALL	GOCPM		;Set up vectors in page 0
	LXI	H,LDRCODE	;Show position of externally loaded code
	SHLD	LOADVEC		;as cold boot vector (cold boot used only once)
	JMP	CCP		;Go to CP/M and execute anything in CCP buffer
;
;----- cold boot subroutines -----
;
;	DISK2 sector relocation table initialization routine.
;
;Entry:	H,L = Base address of unit's relocation table,
;	C = Unit select byte (by specifying the outer logical drive).
;
    if DISK2
D2INIT:	PUSH	H		;Save DMA specification
	CALL	SELDSK		;Set the current active drive specification
	POP	B		;Recover DMA for setup
	CALL	SETDMA		;Save DMA address of table
	MVI  C,(D2$SCNT-1) * 8	;Get relocation table from last sector on drive
	CALL	SETSEC		;Set for first active record (8 / 1K sector)
	CALL	HOME		;Restore pointers and register storage
	JMP	READ		; and read sector at Cylinder 0, Head 0
    endif
;
; Initialize the DISK3 controller.
    if DISK3
D3INIT:	LXI	H,D3CIOPB	;Start of normal CIOPB
	SHLD	D3DIOPB+D3$LINK	;Put link in default IOPB
	SHLD	D3CIOPB+D3$LINK	;Put link in normal IOPB
	XRA	A		;Clear A
	STA	D3DIOPB+D3$LNK3 ;Set default dma address
	STA	D3CIOPB+D3$LNK3	;
	STA	D3CIOPB+D3$DMA3	;Set extended dma address to 0
	MVI M,D3$NOOP ! INX H	;First command is NOOP, point to status
	MOV M,A	! INX H		;Clear status byte, point to drive
	MOV M,A ! DCX H		;Set drive to 0, point back to status
	MVI	A,D3RESET	;Reset DISK3 controller (Select controller #1)
	OUT	D3$PORT
	MVI	A,D3$ATTN
	OUT	D3$PORT		;Send attention to controller
	LXI	B,0FFFH		;Wait only this many times incase no DISK3 
D3INIT3:MOV A,M ! ORA A		;Wait until status non-zero
	JNZ	D3INIT4		;Exit timeout loop if status non-zero
	DCX	B		;Count this wait loop
	MOV A,B ! ORA C		;See if zero reached	
	JNZ	D3INIT3		;Try again if not timed out 
	LXI	H,NOD3		;If timed out ...
	JMP	PRINT		; ....print message and return
;	
D3INIT4:MVI	C,NDISK3-1	;Get number of active drives 
D3INIT1:PUSH	B		;Save current drive
	MOV	A,C		;Get current drive number 
	STA	D3$DRVS+D3CIOPB	;Set current drive number
	MVI	A,D3$HOME	;Home drive first thing
	CALL	D3EXEC		;Execute home command 
	LXI	H,100H		;Read specify sector into TPA
	SHLD	D3$DMA+D3CIOPB	;Set as dma address in DISK3 iopb
	LXI	H,D3CIOPB+3	;Get start of DISK3 arguments
	XRA A			;Clear A
	MVI M,1 ! INX H		;Set as read command
	MOV M,A ! INX H		;Want to start reading at sector 0
	MOV M,A ! INX H		;High byte of sector
	MOV M,A ! INX H		;Want to start reading at track 0
	MOV M,A ! INX H		;High byte of track
	MVI M,2 ! INX H		;Want to read 2 sectors
	MOV M,A ! INX H		;High byte of sector count
	MVI 	A,D3$XFER	;Do DISK3 read/write sector command
	CALL	D3EXEC		;Execute command
	MVI	C,8		;Now compare 1st 8 bytes against signon message
	LXI	H,SIGNON	;Get start of "CompuPro" in signon
	LXI	D,100H		;Get begining of 8 flag bytes
SGNCMP:	LDAX	D		;Get first byte of what is on disk
	CMP	M		;See if it matches signon
	JNZ	NOFMT		;If no match, disk is not formatted right
	INX D ! INX H		;Move both pointers up
	DCR	C		;Count this byte
	JNZ	SGNCMP		;Do 8 bytes
	LXI	H,100H+16	;Point to specify block
	SHLD	D3$DMA+D3CIOPB	;Put address of specify in iopb
	MVI	A,D3$SPEC	;DISK3 specify command
	CALL	D3EXEC		;Tell disk3 to perform specify 
	LXI	H,100H+1024	;Point to start of bad map
	SHLD	D3$DMA+D3CIOPB	;Put address of badmap in iopb
	MVI	A,D3$MAP	;Set badmap command
	CALL	D3EXEC		;Execute command to set the relocation map
D3INIT2:POP	B
	DCR	C		;Count this drive 
	JP	D3INIT1		;Do for all drives
	LXI	H,D3CIOPB+3	;Point at ARG1
	MVI M,0     ! INX H	;Use mode 0
	MVI M,MRTRY ! INX H	;Set number of retries
	MVI M,4     ! INX H	;Max of 4 drives on one disk3
	MVI	A,D3$GLBL	;Disk3 set globals command 
	JMP	D3EXEC		;Execute globals command and return with status
;
NOFMT:	POP B ! PUSH B		;Recover/save drive number
	MOV A,C ! ADI '0'	;Add ascii bias to drive number
	STA	FMTDRV		;Set ascii drive letter in message
	LXI	H,FMTMSG	;Show not formatted message
	CALL	PRINT
	JMP	D3INIT2		;Go do any remaining drives
; 
FMTMSG:	DB	'Hard disk unit '
FMTDRV:	DB	'X not formatted properly.',CR,LF,NULL
NOD3:	DB	'No DISK3 controller.',CR,LF,NULL
    endif
;
	PAGE
; Sign on message -- must be terminated by a "NULL" byte.
SIGNON:	DB	'CompuPro Systems CP/M '
	DB	VERS/10+'0','.',VERS mod 10 + '0',CBIOSV,' '
    if (D2BOOT or D3BOOT)
	DB	'Hard '	;Separator
    endif
	DB	'Disk Loader'
	DB	CR,LF,NULL	;End of sign-on message
;
ENDCODE	EQU  $	;End of active code
;--------------------------------
    if (BOOTSEC * 128) lt (ENDCODE - BIOS) ;If disk storage area insufficeint
--:ERROR:--	Assembly time BOOT SPACE SHORTAGE
SPACE$OVER EQU (ENDCODE - BIOS)-(BOOTSEC * 128)
    else
SPACE$LEFT EQU (BOOTSEC * 128)-(ENDCODE - BIOS)	;Amount of boot space left
    endif
;
;********************************
;*	CP/M DISK WORK SPACE:	*
;********************************
	ORG  REUSE  ;Space recovered from code used only at cold boot time
;
; Allocation vectors (reserved space).
	IRPC	?Y,ABCDEFGHIJKLMNOP
ALV$&?Y	DS	ALVZ&?Y		;;Specific drive allocation vector size
	ENDM
;
; Checksum vectors (reserved space for disk change identification).
	IRPC	?Z,ABCDEFGHIJKLMNOP
CSV$&?Z	DS	CSVZ&?Z		;;Specific drive checksum vector size
	ENDM
;
;-------------------------------
    if DISK2			;Disk 2 controller storage containing
RELTBL0	DS	D2$SCNT * 3	;Sector relocation tables for respective units
    endif
ENDWORK	EQU	$	;End of workspace below block buffers
;-------------------------------
; Place directory, host buffer near final block of RAM.
	ORG  0 - (HSTSIZ + 256)	;Fix on page boundary
;
LDRCODE	EQU   $-XLOADZ	;Base address of externally loaded additional code to
			;add to the BIOS.  Placed here to attain invariance
			;if the associated BIOS is altered in size.
;
    if ENDWORK gt LDRCODE ;Overflow of storage space requirement
--:ERROR:--	Assembly time STORAGE SPACE SHORTAGE
NEED$SPACE EQU	(ENDWORK - LDRCODE)
    else
SPARE$RAM EQU	(LDRCODE - ENDWORK)
    endif
;
HSTBUF	DS	HSTSIZ	;Host buffer (sector blocking/deblocking)
DIRBUF	DS	128	;Directory buffer
;
; Disk access information.
; This area is organized into the following groups:
;	  1) Sector number.
;	2,3) Track number.
;	  4) Disk drive.
;	  5) Drive type.
; Each of these groups has three cells for the current disk request,
; ACTual disk transfer, and active host disk.
;
SAVSEC	DS	2	;Special storage for record in use
NUMSEC	DS	1	;Number of sectors
;
;	User (desired, seek to) Data Buffer Address, Parameters.
;
DMAADR	DS	2	;Lower 16 bits (least, middle)
DMAADE	DS	1	;Extended address
;
SEKSEC	DS	1	;Current sector request
SEKGPL	DS	1	;Current sector gap length
SEKTRK	DS	2	;Current track request
SEKDSK	DS	1	;Current disk number request
SEKTYP	DS	1	;Current disk's type
;
;	(Active) Physical Data Buffer Address, Parameters.
;
BUFADR	DS	2	;Lower 16 bits (least, middle)
BUFADE	DS	1	;Extended address
;
ACTSEC	DS	1	;Actual transfer operation
ACTGPL	DS	1	;Actual sector gap length used
ACTTRK	DS	2	;Actual transfer operation
ACTDSK	DS	1	;Actual transfer operation
ACTTYP	DS	1	;Actual disk's type
;
;	Host Disk Physical Parameters.
;
HSTSEC	DS	1	;Active host disk
HSTGPL	DS	1	;Host sector gap length
HSTTRK	DS	2	;Active host disk
HSTDSK	DS	1	;Active host disk
HSTTYP	DS	1	;Active disk's type
;
;	Floppy Disk "Command Input/Output Parameter Block" for controller ops.
;
CIOPL	EQU	9
CIOPB	DS	CIOPL	;Disk command buffer
TEMPBF	DS	8	;Result status cells
	if DISK3
;		Command, Status, Drive, Read/Write flag
D3CIOPB:DS	4
	DS	2		;Sector
	DS	2		;Track
	DS	2		;Number of sectors to xfer
	DS	2		;Initial Specification Parameters
	DS	1		;In current bank
	DS	2		;Link returns to start of this IOPB
	DS	1		;In current bank as well
    endif
;-------------------------------
;
	ORG	ENDCODE	;Show end of booted code address to user
;
	END		;Das Ende
